//+---------------------------------------------------------------------------------+
//|                                                               LimitNet+Stop.mq4 |
//|                                                                           Verdi |
//|                                                                 nemo811@mail.ru |
//|     limit-   .   |
//|  Lot limit-    .       |
//|takeprofit         0.          |
//|Limit-  Stop- (TP,SL,Magic = 0)          |
//|.  R_Lot  R_point     (!)(!) |
//|  (    - ).            |
//|                |
//|   .                                                       |
//|      :                            |
//| -   1  = 1 : 10 000                                          |
//| -    = 4%                                                          |
//| -   1     0.1  = 37 .                     |
//| -    = 150 .                                           |
//+---------------------------------------------------------------------------------+
#property copyright "Verdi"
#property link      "nemo811@mail.ru"
#property show_inputs
//--------------------------------------------------------------------
extern int     Magic       = 0;      //    ( Stop-)
extern bool    BUY         = false;  //  BUY    BUY LIMIT
extern bool    SELL        = false;  //  SELL    SELL LIMIT
extern double  Lot         = 0.1;    //     limit-
extern int     delta       = 37;     // 
extern int     MaxOrders   = 2;      //- limit- 
extern int     takeprofit  = 37;     //  TP,  0,  TP   zero_tp               
extern int     stoploss    = 0;      //  SL,  0,  SL  
extern string  corr=" ";
extern int     zero_tp     = 1;      //  takeprofit      0,  0,
                                     // takeprofit    (!) 1  0(!)
extern int     R_Lot       = 1;      //  Lot    (!)(!)  ,  0 -
                                     //  +  R_point,   Lot: R_Lot*Lot=   
extern int     R_point     = 37;     // Loss     (!)(!),  0 -   
//--------------------------------------------------------------------
double SL,TP,Price,Sum,DeltaProfitR,DeltaProfitL;
//--------------------------------------------------------------------
int start()
{
   for (int x=1; x<=1; x++)
   {
      DeltaProfitR = (Lot*R_Lot*R_point)/(Lot+Lot*R_Lot);
      if (BUY)
      {
         if (takeprofit!=0) TP  = NormalizeDouble(Ask + (takeprofit+DeltaProfitR*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL  = NormalizeDouble(Ask - stoploss*Point,Digits); else SL=0;     
         OPENORDER ("Buy",Price,SL,TP,x);
      }
      if (SELL)
      {  
         if (takeprofit!=0) TP = NormalizeDouble(Bid - (takeprofit+DeltaProfitR*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL = NormalizeDouble(Bid + stoploss*Point,Digits);  else SL=0;              
         OPENORDER ("Sell",Price,SL,TP,x);
      }
   }
   double Sum=0;
   for (int i=1; i<=MaxOrders; i++)
   {
      if (BUY)
      {
         Price = NormalizeDouble(Ask-delta*i*Point,Digits);
         Sum=Sum+delta*(2*Lot+Lot*(i-2))*(i-1)/2;
         DeltaProfitL = (Sum+i*delta*Lot+Lot*R_Lot*R_point+Lot*R_Lot*delta*i)/((2*Lot+Lot*(i-1))*i/2+Lot+Lot*R_Lot);
         if (takeprofit!=0) TP  = NormalizeDouble(Price + (takeprofit + DeltaProfitL*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL  = NormalizeDouble(Price - stoploss*Point,Digits); else SL=0;     
         OPENORDER ("Buy Limit",Price,SL,TP,i);
      }
      if (SELL)
      {  
         Price = NormalizeDouble(Bid+delta*i*Point,Digits);
         Sum=Sum+delta*(2*Lot+Lot*(i-2))*(i-1)/2;
         DeltaProfitL = (Sum+i*delta*Lot+Lot*R_Lot*R_point+Lot*R_Lot*delta*i)/((2*Lot+Lot*(i-1))*i/2+Lot+Lot*R_Lot);
         if (takeprofit!=0) TP = NormalizeDouble(Price - (takeprofit + DeltaProfitL*zero_tp)*Point,Digits); else TP=0;
         if (stoploss!=0)   SL = NormalizeDouble(Price + stoploss*Point,Digits);  else SL=0;              
         OPENORDER ("Sell Limit",Price,SL,TP,i);
      }
   }
   for (int v=1; v<=1; v++)
   {
      if (BUY)
      {
         OPENORDER ("Sell Stop",Price,SL,TP,v);
      }
      if (SELL)
      {  
         OPENORDER ("Buy Stop",Price,SL,TP,v);
      }
   }
return(0);
}
//--------------------------------------------------------------------
void OPENORDER(string ord,double Price,double SL,double TP,int i)
{
   int ticket = -1;
   int err;
   while (ticket<0)
   {
      if (ord=="Buy") ticket=OrderSend(Symbol(),OP_BUY, Lot,NormalizeDouble(Ask,Digits),3,SL,TP,"Magic_" + Magic,Magic,0);
      if (ord=="Sell") ticket=OrderSend(Symbol(),OP_SELL,Lot,NormalizeDouble(Bid,Digits),3,SL,TP,"Magic_" + Magic,Magic,0);
      if (ord=="Buy Limit") ticket=OrderSend(Symbol(),OP_BUYLIMIT, Lot*i,Price,3,SL,TP,StringConcatenate(""+i,"  Magic_" + Magic),Magic,0);
      if (ord=="Sell Limit") ticket=OrderSend(Symbol(),OP_SELLLIMIT,Lot*i,Price,3,SL,TP,StringConcatenate(""+i,"  Magic_" + Magic),Magic,0);
      if (ord=="Buy Stop") ticket=OrderSend(Symbol(),OP_BUYSTOP,(2*Lot+Lot*(MaxOrders-1))*MaxOrders/2+Lot+Lot*R_Lot,NormalizeDouble(Ask+delta*(MaxOrders+1)*Point,Digits),3,0,0,"Lock, Magic_0",0,0);
      if (ord=="Sell Stop") ticket=OrderSend(Symbol(),OP_SELLSTOP,(2*Lot+Lot*(MaxOrders-1))*MaxOrders/2+Lot+Lot*R_Lot,NormalizeDouble(Bid-delta*(MaxOrders+1)*Point,Digits),3,0,0,"Lock, Magic_0",0,0);
      Message(Magic);
      if (ticket==-1)
      {  
         ShowERROR();
         err++;Sleep(2000);RefreshRates();
      }
      if (ticket!=-1 || err >10) return;
   }
return;
}                  
//--------------------------------------------------------------------
void Message(string Magic) {
  Comment("Magic_" + Magic);
  Print("Magic_" + Magic);
}                                      
//--------------------------------------------------------------------
void ShowERROR()
{
   int err=GetLastError();
   switch ( err )
   {                  
      case 1:   return;
      case 2:   Alert("     ",Symbol());return;
      case 3:   Alert("Error   ",Symbol());return;
      case 130: Alert("Error     Ticket ",Symbol());return;
      case 134: Alert("    ",Symbol());return;
      case 146: Alert("Error    ",Symbol());return;
      case 129: Alert("Error   ",Symbol());return;
      case 131: Alert("Error   ",Symbol());return;
      default:  Alert("Error  " ,err," ",Symbol());return;
   }
}
//--------------------------------------------------------------------

